diff --git a/Units/parser-ada.r/ada-overriding.d/args.ctags b/Units/parser-ada.r/ada-overriding.d/args.ctags
index 5ee5f79f70..602e7db70d 100644
--- a/Units/parser-ada.r/ada-overriding.d/args.ctags
+++ b/Units/parser-ada.r/ada-overriding.d/args.ctags
@@ -1 +1,2 @@
+--kinds-Ada=+E
 --sort=no
diff --git a/Units/parser-ada.r/ada-overriding.d/expected.tags b/Units/parser-ada.r/ada-overriding.d/expected.tags
index 733e77d8d0..ca851bb805 100644
--- a/Units/parser-ada.r/ada-overriding.d/expected.tags
+++ b/Units/parser-ada.r/ada-overriding.d/expected.tags
@@ -1,5 +1,6 @@
 Input	input.ads	/^package Input$/;"	P
 Tasche_T	input.ads	/^   task type Tasche_T is new Carte_T with$/;"	K	packspec:Input
+Coucou	input.ads	/^      entry Coucou;$/;"	E	taskspec:Tasche_T
 Inutile	input.ads	/^   procedure Inutile$/;"	R	packspec:Input
 input_2	input_2.adb	/^package body input_2$/;"	p
 Tasche_T	input_2.adb	/^   task body Tasche_T is$/;"	k	package:input_2	file:
diff --git a/parsers/ada.c b/parsers/ada.c
index 7b24814c1d..ed1ec60bfb 100644
--- a/parsers/ada.c
+++ b/parsers/ada.c
@@ -1016,8 +1016,19 @@ static adaTokenInfo *adaParseBlock(adaTokenInfo *parent, adaKind kind)
       }
       else if(adaKeywordCmp(ADA_KEYWORD_NEW))
       {
-        /* if this is a "new" something then no need to parse */
-        skipPast(";");
+        struct cmpKeywordOrWordDataElt *elt;
+
+        elt = skipPastKeywordOrWord ((struct cmpKeywordOrWordDataElt []) {{
+              .type = ELT_KEYWORD,
+              .u.keyword = ADA_KEYWORD_WITH,
+              }, {
+              .type = ELT_WORD,
+              .u.word = ";",
+              }
+          }, 2);
+
+        if (elt && elt->type == ELT_KEYWORD)
+          adaParse(ADA_DECLARATIONS, token);
       }
       else
       {
